//OursCalc.cpp

#include "stdafx.h"
#include "Orw.h"
#include "OrwCalc.h"
#include <math.h>
/////////////////////////////////////////////////////////////////////////////
extern COrwApp* pApp;
/////////////////////////////////////////////////////////////////////////////
double CalcRound( double Data, int Place)
{
	//LPlaceɎľܓ
	double Ret = floor( floor( fabs( Data) * ( pow( 10, Place + 1) + 1e-14) + 5) / 10) / pow( 10, Place);
	if ( Data >= 0) return Ret;
	else return -Ret;
}

void RoundData( double* pValue)
{
	//i[double͈̔͂z𐴑|
	int Place = 0;
	if ( *pValue != 0)
	{
		Place = (int)log10( fabs( *pValue)) + 1;
	}
	*pValue = CalcRound( *pValue, 15 - Place);	//̒l//14->15
}

void RoundData( CPoint2D* pPoint)
{
	//i[double͈̔͂z𐴑|
	int PlaceX = 0;
	int PlaceY = 0;
	if ( pPoint->x != 0)
	{
		PlaceX = (int)log10( fabs( pPoint->x)) + 1;
	}
	if ( pPoint->y != 0)
	{
		PlaceY = (int)log10( fabs( pPoint->y)) + 1;
	}
	pPoint->x = CalcRound( pPoint->x, 14 - PlaceX);
	pPoint->y = CalcRound( pPoint->y, 14 - PlaceY);
}

double Subtract( double* pValueA, double* pValueB)
{
	//ľZlSubtract()̔̌Ŋۂ߂ĕԂ
	int PlaceA = 0;
	int PlaceB = 0;
	if ( *pValueA != 0)
	{
		PlaceA = (int)log10( fabs( *pValueA)) + 1;
	}
	if ( *pValueB != 0)
	{
		PlaceB = (int)log10( fabs( *pValueB)) + 1;
	}
	double Dab = *pValueA - *pValueB;
	Dab = CalcRound( Dab, 12 - (int)max( PlaceA, PlaceB));
	return Dab;
}

BOOL SameValuePlace( double ValueA, double ValueB, int Place)
{
	//l//Place:_ȉ
	double Margin = pow( 10, -Place);
	if ( fabs( ValueB - ValueA) < Margin) return TRUE;
	return FALSE;
}

BOOL SameValue( double ValueA, double ValueB)
{
	//l
	BOOL SmallA = FALSE;
	return SameValue( ValueA, ValueB, &SmallA);
}

BOOL SameValue( double ValueA, double ValueB, BOOL* pSmallA)
{
	//l
	*pSmallA = FALSE;
	if ( ValueA == 0 || ValueB == 0)
	{
		BOOL Ret = SameValuePlace( ValueA, ValueB, 4);
		if ( !Ret)
		{
			if ( ValueA < ValueB)
			{
				*pSmallA = TRUE;
			}
		}
		return Ret;
	}
	int PlaceA = (int)log10( fabs( ValueA)) + 1;
	int PlaceB = (int)log10( fabs( ValueB)) + 1;
	if ( PlaceA <= -12 && PlaceB <= -12)
	{
		ValueA += 1e-5;
		ValueB += 1e-5;
		PlaceA = (int)log10( fabs( ValueA)) + 1;
		PlaceB = (int)log10( fabs( ValueB)) + 1;
	}
	int Place = max( PlaceA, PlaceB);
	double Margin = pow( 10, Place - 10);
	double DD = ValueB - ValueA;
	if ( fabs( DD) < Margin) return TRUE;
	if ( DD > 0) *pSmallA = TRUE;
	return FALSE;
}

BOOL SamePoint( CPoint2D* pPointA, CPoint2D* pPointB)
{
	BOOL SmallA;
	double Ax = pPointA->x;
	double Ay = pPointA->y;
	double Bx = pPointB->x;
	double By = pPointB->y;
	BOOL SameX = SameValue( Ax, Bx, &SmallA);
	BOOL SameY = SameValue( Ay, By, &SmallA);
	if ( SameX && SameY) return TRUE;
	return FALSE;
}

CString intToStr( int* pData)
{
	char Buff[ 30];
	_itoa( *pData, Buff, 10);
	CString RetString = Buff;
	return RetString;
}

void TrimSpace( CString* pString)
{
	//O" ""@"
	CString String = *pString;
	for ( int ii = 0; ii < 20; ii++)
	{
		CString LeftA = String.Left( 1); 
		CString LeftB = String.Left( 2); 
		CString RightA = String.Right( 1); 
		CString RightB = String.Right( 2); 
		if ( LeftA != " " && LeftB != "@" && RightA != " " && RightB != "@")
		{
			break;
		}
		if ( LeftA == " ")
		{
			String.TrimLeft();
		}
		else if ( LeftB == "@")
		{
			String = String.Right( String.GetLength() - 2);
		}
		if ( RightA == " ")
		{
			String.TrimRight();
		}
		else if ( RightB == "@")
		{
			String = String.Left( String.GetLength() - 2);
		}
	}
	*pString = String;
}

void SwapDouble( double* pA, double* pB)
{
	double C = *pA;
	*pA = *pB;
	*pB = C;
}

void SwapPoint( CPoint2D* pPointA, CPoint2D* pPointB)
{
	//_f[^̓ւ
	SwapDouble( &pPointA->x, &pPointB->x);
	SwapDouble( &pPointA->y, &pPointB->y);
}

BOOL SortPoint( CPoint2D* pPointA, CPoint2D* pPointB)
{
	//A.x < B.x || A.x = B.x & A.y < B.y Ƃ
	BOOL Swaped = FALSE;
	BOOL Small;
	if ( SameValue( pPointA->x, pPointB->x, &Small))
	{
		if ( pPointB->y < pPointA->y)
		{
			SwapPoint( pPointA, pPointB);
			Swaped = TRUE;
		}
	}
	else if ( pPointB->x < pPointA->x)
	{
		SwapPoint( pPointA, pPointB);
		Swaped = TRUE;
	}
	return Swaped;
}

double CalcRadian( double* pDx, double* pDy, double* pLength)
{
	//-pi~piWAZ
	double pi = 3.141592653589793;
	double Angle;
	double LengRatio;
	*pLength = sqrt( (*pDx) * (*pDx) + (*pDy) * (*pDy));
	if ( *pLength == 0) return 0;
	if ( fabs(*pDx) >= fabs(*pDy) )
	{
		LengRatio = *pDx / *pLength;
		if ( LengRatio > 1) return 0;
		else if ( LengRatio < -1) return pi;
		Angle = acos( LengRatio);
		if ( *pDy < 0 )
		{
			Angle = 0 - Angle;
		}
	}
	else
	{
		LengRatio = *pDy / *pLength;
		if ( LengRatio > 1) return pi / 2;
		else if ( LengRatio < -1) return pi * 3 / 2;
		Angle = asin( LengRatio);
		if ( *pDx < 0 )
		{
			if ( *pDy >= 0)
			{
				Angle = pi - Angle;
			}
			else
			{
				Angle = -pi - Angle;
			}
		}
	}
	return Angle;
}

char GetSlantSE( CPoint2D* pSpoint, CPoint2D* pEpoint)
{
	//Slant𓾂
	char Slant = 4;
	if ( SameValue( pEpoint->y, pSpoint->y))
	{
		Slant = 1;
	}
	else if ( SameValue( pEpoint->x, pSpoint->x))
	{
		Slant = 2;
	}
	return Slant;
}

BOOL CheckArcRadianCalc( double Radian, double RadianS, double RadianE)
{
	//pxS,E͈̔͂ɂ邩̔
	double pi = 3.141592653589793;
	ASSERT( RadianS < RadianE);
	RoundData( &Radian);
	if ( SameValuePlace( Radian, RadianS, 3))
	{
		if ( SameValuePlace( Radian, RadianE, 3) || Radian < RadianE)
		{
			return TRUE;
		}
		else if ( SameValuePlace( Radian - 2 * pi, RadianS, 3) || Radian - 2 * pi > RadianS)
		{
			if ( SameValuePlace( Radian - 2 * pi, RadianE, 3) || Radian - 2 * pi < RadianE)
			{
				return TRUE;
			}
		}
	}
	else if ( Radian < RadianS)
	{
		if ( SameValuePlace( Radian + 2 * pi, RadianS, 3) || Radian + 2 * pi > RadianS)
		{
			if ( SameValuePlace( Radian + 2 * pi, RadianE, 3) || Radian + 2 * pi < RadianE)
			{
				return TRUE;
			}
		}
		else if ( Radian + 4 * pi >= RadianS)
		{
			if ( SameValuePlace( Radian + 4 * pi, RadianE, 3) || Radian + 4 * pi < RadianE)
			{
				return TRUE;
			}
		}
	}
	else if ( Radian > RadianS)
	{
		if ( SameValuePlace( Radian, RadianE, 3) || Radian < RadianE)
		{
			return TRUE;
		}
		else if ( SameValuePlace( Radian - 2 * pi, RadianS, 3) || Radian - 2 * pi > RadianS)
		{
			if ( SameValuePlace( Radian - 2 * pi, RadianE, 3) || Radian - 2 * pi < RadianE)
			{
				return TRUE;
			}
		}
	}
	return FALSE;
}

double CalcDistance( CPoint2D* pPointA, CPoint2D* pPointB)
{
	double Dx = pPointB->x - pPointA->x;
	double Dy = pPointB->y - pPointA->y;
	double Distance = sqrt( Dx * Dx + Dy * Dy);
	return Distance;
}

BOOL GetArcRadianByX( double* pDrawRadius, double* pDx, BOOL Upper, double* pCy, double* pTop, double* pBottom, double* pRadian)
{
	double pi = 3.141592653589793;
	*pRadian = acos( *pDx / *pDrawRadius);
	if ( *pDx > *pDrawRadius || *pDx < -*pDrawRadius) return FALSE;
	if ( !Upper)
	{
		*pRadian = 2 * pi - *pRadian;
	}
	double Py = *pCy + *pDrawRadius * sin( *pRadian);
	if ( Py > *pTop)
	{
		return FALSE;
	}
	if ( Py < *pBottom)
	{
		return FALSE;
	}
	return TRUE;
}

BOOL GetArcRadianByY( double* pDrawRadius, double* pDy, BOOL Left, double* pCx, double* pLeft, double* pRight, double* pRadian)
{
	double pi = 3.141592653589793;
	*pRadian = asin( *pDy / *pDrawRadius);
	if ( *pDy > *pDrawRadius || *pDy < -*pDrawRadius) return FALSE;
	if ( Left)
	{
		*pRadian = pi - *pRadian;
	}
	else if ( *pRadian < 0)
	{
		*pRadian = 2 * pi + *pRadian;
	}
	double Px = *pCx + *pDrawRadius * cos( *pRadian);
	if ( Px < *pLeft)
	{
		return FALSE;
	}
	if ( Px > *pRight)
	{
		return FALSE;
	}
	return TRUE;
}

CPoint2D CalcRotPoint( CPoint2D* pPoint, CPoint2D* pBasePoint, double* pDegree)
{
	//_𒆐S_Ɏwpx]_Ԃ
	double pi = 3.141592653589793;
	double Dx = Subtract( &pPoint->x ,&pBasePoint->x);
	double Dy = Subtract( &pPoint->y ,&pBasePoint->y);
	double Length;
	double RotRadian = CalcRadian( &Dx, &Dy, &Length) + *pDegree * pi / 180;
	CPoint2D NewPoint( pBasePoint->x + Length * cos( RotRadian), pBasePoint->y + Length * sin( RotRadian));
	return NewPoint;
}

CPoint2D CalcRotPointRadian( CPoint2D* pPoint, CPoint2D* pBasePoint, double* pRadian)
{
	//_𒆐S_Ɏwpx]_Ԃ
	double Dx = Subtract( &pPoint->x ,&pBasePoint->x);
	double Dy = Subtract( &pPoint->y ,&pBasePoint->y);
	double Length;
	double RotRadian = CalcRadian( &Dx, &Dy, &Length) + *pRadian;
	CPoint2D NewPoint( pBasePoint->x + Length * cos( RotRadian), pBasePoint->y + Length * sin( RotRadian));
	return NewPoint;
}

///////////////////////////////////////////////////////////////////////////////
