//OursData.cpp

#include "stdafx.h"
#include "Orw.h"
#include "MainFrm.h"
#include "OrwDoc.h"
#include "OrwView.h"
#include "OrwCalc.h"
#include <math.h>	//for fabs()
///////////////////////////////////////////////////////////////////////////////
// CPoint2D

CPoint2D::CPoint2D()
{
	x = 0;
	y = 0;
}

CPoint2D::CPoint2D( double A, double B)
{
	x = A;
	y = B;
}

CPoint2D::CPoint2D( CPoint2D* pPoint2D)
{
	x = pPoint2D->x;
	y = pPoint2D->y;
}

CPoint2D CPoint2D::DataToDoc( CPoint2D* pDocBase, double* pDocRatio)
{
	//f[^hLg̍WɊZ(doublê܂)
	//(-7-(-6.9999999997925))*70368744177664=-16004.~-16008.Ő΂߂ɕ\ꂽ
	//sm萔l//f[^o^ɉJbgƔȂ
	double Dx = x - pDocBase->x;
	double Dy = y - pDocBase->y;
	double Px = Dx * *pDocRatio;
	double Py = Dy * *pDocRatio;
	CPoint2D DocPoint( Px, Py);
	return DocPoint;
}

///////////////////////////////////////////////////////////////////////////////
// CRect2D

CRect2D::CRect2D()
{
	left = 0;
	top = 0;
	right = 0;
	bottom = 0;
}

CRect2D::CRect2D( double A, double B, double C, double D)
{
	left = A;
	top = B;
	right = C;
	bottom = D;
}

CRect2D::CRect2D( CRect* pRect)
{
	left = pRect->left;
	top = pRect->top;
	right = pRect->right;
	bottom = pRect->bottom;
}

void CRect2D::NormalizeRect()
{
	if ( left > right) SwapDouble( &left, &right);
	if ( top < bottom) SwapDouble( &top, &bottom);
}

BOOL CRect2D::PointInRect( CPoint2D* pPoint)
{
	if ( pPoint->x >= left && pPoint->x <= right)
	{
		if ( pPoint->y <= top && pPoint->y >= bottom)
		{
			return TRUE;
		}
	}
	return FALSE;
}

void CRect2D::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CLine LineA( left, top, right, top); 
	CLine LineB( left, bottom, right, bottom); 
	CLine LineC( left, bottom, left, top); 
	CLine LineD( right, bottom, right, top); 
	LineA.DrawH( pDC, pDocBase, pDocRatio, pDrawRect);
	LineB.DrawH( pDC, pDocBase, pDocRatio, pDrawRect);
	LineC.DrawV( pDC, pDocBase, pDocRatio, pDrawRect);
	LineD.DrawV( pDC, pDocBase, pDocRatio, pDrawRect);
}

///////////////////////////////////////////////////////////////////////////////

CDatasDammy::CDatasDammy( int Size)
{
	m_Size = Size;
	for ( int ii = 0; ii < 100; ii++)
	{
		m_Number[ ii] = -1;
	}
}

int CDatasDammy::CheckData()
{
	int Count = 0;
	for ( int ii = 0; ii < m_Size; ii++)
	{
		if ( m_Number[ ii] == -1) continue;
		Count++;
	}
	return Count;
}

/////////////////////////////////////////////////////////////////////////////

CElementIndex::CElementIndex()
{
	m_Flags = 1;		//display,searchable,editable
	m_Type = 0;			//Line(1) Circle(2) Arc(3) Text(4)
	m_IndexM = 0;
	m_IndexS = 0;
	m_ModePoint = 0;	//UNDO_MOVE̎1,2,1+2//UNDO_NEW̎0
};

CElementIndex::CElementIndex( WORD Type, short int IndexM, short int IndexS, 
			unsigned char Flags, unsigned char Selected)
{
	m_Type = Type;
	m_IndexM = IndexM;
	m_IndexS = IndexS;
	m_Flags = Flags;
	m_ModePoint = 0;	//UNDO_MOVE̎1,2,1+2//UNDO_NEW̎0
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CGroup, CObject, 0)

CGroup::CGroup()
{
	m_Flags = 1;
	m_TypeGroup = 0;
	m_IndexGroup = -1;
}

CGroup::~CGroup()
{
	for ( int ii = 0; ii < m_ElementIndexArray.GetSize(); ii++)
	{
		CElementIndex* pElementIndex = (CElementIndex*)m_ElementIndexArray.GetAt( ii);
		delete pElementIndex;
	}
	m_ElementIndexArray.RemoveAll();
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CTypePen, CObject, 0)

CTypePen::CTypePen()
{
	m_Type = PS_SOLID;
	m_Width = 1;
	m_Color = 0;
	m_WidthShade = 0;
	m_BaseValueShade = 70;			//SHADE_BASE %

}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CTypeFont, CObject, 0)

CTypeFont::CTypeFont()
{
	memset( &m_logFont, 0, sizeof(LOGFONT));
		m_logFont.lfHeight = -8;
		m_logFont.lfWeight = 400;						//W̑
		m_logFont.lfCharSet = SHIFTJIS_CHARSET;			//WinGdi.h////ꂪƕN
		m_logFont.lfOutPrecision = OUT_STROKE_PRECIS;	//o͐x
		m_logFont.lfClipPrecision = CLIP_STROKE_PRECIS;	//NbsOx
		m_logFont.lfQuality = DRAFT_QUALITY;			//葽̃tHgTCYp\//i͒ႭȂ邱Ƃ
		m_logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
		strcpy( m_logFont.lfFaceName, "lr SVbN"); 
	m_ArrangeString = 1;
	m_FormString = FSTR_Norm;
	m_Direction = DTEXT_Horz;
	m_GapText = GTEXT_Non;
	m_SizeString = STEXT_Fix;
	m_Degree = 0;
	m_RatioGapText = 0;
	m_LeftString = FALSE;
	m_SizeTextBBBBB.cy = 80;		//8mm
	m_SizeTextBBBBB.cx = 40;
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CLayer, CObject, 0)

CLayer::CLayer()
{
}

void CLayer::SetName( int IndexLayer)
{
	//default name set
	CString Name;
	if ( IndexLayer < 10) Name = "000";
	else if ( IndexLayer < 100) Name = "00";
	else if ( IndexLayer < 1000) Name = "0";
	Name += intToStr( &IndexLayer);
	m_Name = Name;
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CDataString, CObject, 0)

CDataString::CDataString()
{
};

CDataString::CDataString( CString String)
{
	m_Flags = 1;				//Active
	m_Strings = String;
};

CDataString::~CDataString()
{
	for ( int ii = 0; ii < m_ElementIndexArray.GetSize(); ii++)
	{
		CElementIndex* pElementIndex = (CElementIndex*)m_ElementIndexArray.GetAt( ii);
		delete pElementIndex;
	}
	m_ElementIndexArray.RemoveAll();
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CDataPoint, CObject, 0)

CDataPoint::CDataPoint()
{
	m_Flags = 1;
	m_Point = CPoint2D( 0, 0);
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = POINT_Normal;
};

void CDataPoint::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CDataPoint::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	CPoint2D Point = m_Point.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = pDrawRect->PointInRect( &Point);
	if ( !InnerRect)
	{
		return;
	}
	CPoint SpointA = Point.ToLong();
	CPoint EpointA = Point.ToLong();
	CPoint SpointB = Point.ToLong();
	CPoint EpointB = Point.ToLong();
	SpointA.x -= 10;		//f[^_̕`ЃTCY
	EpointA.x += 10;
	SpointB.y -= 10;
	EpointB.y += 10;
	pDC->MoveTo( SpointA);	
	pDC->LineTo( EpointA);
	pDC->MoveTo( SpointB);	
	pDC->LineTo( EpointB);
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CDataPoints, CObject, 0)

CDataPoints::CDataPoints()
{
	m_Size = 0;
	m_IndexPen = 0;
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CLine, CObject, 0)

CLine::CLine()
{
	m_Flags = 1;
	m_Spoint = CPoint2D( 0, 0);
	m_Epoint = CPoint2D( 0, 0);
	m_Swaped = FALSE;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = LINE_Normal;
};

CLine::CLine( CPoint2D Spoint, CPoint2D Epoint)
{
	m_Flags = 1;
	m_Spoint = Spoint;
	m_Epoint = Epoint;
	m_Swaped = FALSE;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = LINE_Normal;
};

CLine::CLine( double Sx, double Sy, double Ex, double Ey)
{
	m_Flags = 1;
	m_Spoint.x = Sx;
	m_Spoint.y = Sy;
	m_Epoint.x = Ex;
	m_Epoint.y = Ey;
	m_Swaped = FALSE;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = LINE_Normal;
};

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CLines, CObject, 0)

CLines::CLines()
{
	m_Slant = 4;
	m_Size = 0;
	m_IndexPen = 0;
}

void CLine::DrawH( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	DrawH( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CLine::DrawV( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	DrawV( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CLine::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CLine::DrawH( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)Epoint.x, (int)Epoint.y);
}

void CLine::DrawV( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)Epoint.x, (int)Epoint.y);
}

void CLine::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)Epoint.x, (int)Epoint.y);
}

/////////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CCircle, CObject, 0)

CCircle::CCircle()
{
	m_Flags = 1;
	m_Center = CPoint2D( 0, 0);
	m_Radius = 0;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = CIRCLE_Normal;
};

void CCircle::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CCircle::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	double pi = 3.141592653589793;
	double DrawRadius = m_Radius * *pDocRatio;
	if ( DrawRadius < 1) return;
	double Cx = ( m_Center.x - pDocBase->x) * *pDocRatio;
	double Cy = ( m_Center.y - pDocBase->y) * *pDocRatio;
	if ( DrawRadius < 4)
	{
		if ( Cx >= pDrawRect->left && Cx < pDrawRect->right && Cy <= pDrawRect->top && Cy >= pDrawRect->bottom)
		{
			double UnitDadian = pi / 2;
			int Sx =  (int)( Cx + DrawRadius); 
			int Sy =  (int)( Cy); 
			pDC->MoveTo( Sx, Sy);
			for ( int ii = 1; ii <= 4; ii++)
			{
				int Ex =  (int)( Cx + DrawRadius * cos( ii * UnitDadian)); 
				int Ey =  (int)( Cy + DrawRadius * sin( ii * UnitDadian)); 
				pDC->LineTo( Ex, Ey);
			}
		}
		return;
	}
	double left = Cx - DrawRadius;
	double right = Cx + DrawRadius;
	double top = Cy + DrawRadius;
	double bottom = Cy - DrawRadius;
	double Aradian, Bradian;
	if ( left > 0 &&right < 32767 && top < 0 && bottom > -32767)
	{
		
			//ClipArcsgp̂
			Aradian = 0;
			Bradian = 2 * pi;
		
		int Sx = (int)( Cx + DrawRadius * cos( Aradian));
		int Sy = (int)( Cy + DrawRadius * sin( Aradian));
		int Ex = (int)( Cx + DrawRadius * cos( Bradian));
		int Ey = (int)( Cy + DrawRadius * sin( Bradian));
		pDC->Arc( (int)left, (int)top, (int)right, (int)bottom, Sx, Sy, Ex, Ey);
	}
	else
	{
		double UnitRadian = 100 / DrawRadius;	//100LP̌

			//ClipArcsgp̂
			Aradian = 0;
			Bradian = 2 * pi;

		int SliceNum = (int)( fabs( Bradian - Aradian) / UnitRadian) + 1;
		UnitRadian = ( Bradian - Aradian) / SliceNum;
		int Px = (int)( Cx + DrawRadius * cos( Aradian));
		int Py = (int)( Cy + DrawRadius * sin( Aradian));
		pDC->MoveTo( Px, Py);	
		for( double Rad = Aradian + UnitRadian; Rad < Bradian + UnitRadian; Rad += UnitRadian)
		{
			Px = (int)( Cx + DrawRadius * cos( Rad));
			Py = (int)( Cy + DrawRadius * sin( Rad));
			pDC->LineTo( Px, Py);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CCircles, CObject, 0)

CCircles::CCircles()
{
	m_Size = 0;
	m_IndexPen = 0;
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CArc, CObject, 0)

CArc::CArc()
{
	m_Flags = 1;
	m_Center = CPoint2D( 0, 0);
	m_Degree = CPoint2D( 0, 0);
	m_Ccw = TRUE;
	m_Radius = 0;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = ARC_Normal;
};

void CArc::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CArc::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	double pi = 3.141592653589793;
	double DrawRadius = m_Radius * *pDocRatio;
	if ( DrawRadius < 1) return;
	double Cx = ( m_Center.x - pDocBase->x) * *pDocRatio;
	double Cy = ( m_Center.y - pDocBase->y) * *pDocRatio;
	double Sradian = m_Degree.x * pi / 180;
	double Eradian = m_Degree.y * pi / 180;
	double ArcRadian = Eradian - Sradian;
	if ( ArcRadian < 0.00017) return;	//0.01x
	if ( DrawRadius < 4)
	{
		if ( Cx >= pDrawRect->left && Cx < pDrawRect->right && Cy <= pDrawRect->top && Cy >= pDrawRect->bottom)
		{
			double UnitDadian = pi / 2;
			int CountSlice = (int)( fabs( ArcRadian) / UnitDadian) + 1;
			UnitDadian = ArcRadian / CountSlice;
			int Sx = (int)( Cx + DrawRadius * cos( Sradian)); 
			int Sy = (int)( Cy + DrawRadius * sin( Sradian)); 
			pDC->MoveTo( Sx, Sy);
			for ( double Rad = Sradian + UnitDadian; Rad <= Eradian + UnitDadian / 2; Rad += UnitDadian)
			{
				int Ex =  (int)( Cx + DrawRadius * cos( Rad)); 
				int Ey =  (int)( Cy + DrawRadius * sin( Rad)); 
				pDC->LineTo( Ex, Ey);
			}
		}
		return;
	}
	double left = Cx - DrawRadius;
	double right = Cx + DrawRadius;
	double top = Cy + DrawRadius;
	double bottom = Cy - DrawRadius;
	double Aradian, Bradian;
	
		//ClipArcsgp̂
		Aradian = Sradian;
		Bradian = Eradian;
	
	BOOL ModeSeparate = FALSE;
	if ( fabs( Bradian - Aradian - 2 * pi) < 0.001)	//̒l
	{
		Aradian = Sradian;
		Bradian = Eradian;
	}
	else
	{
		if ( CheckArcRadianCalc( Sradian, Aradian, Bradian) &&
			 CheckArcRadianCalc( Eradian, Aradian, Bradian))
		{
			if ( CheckArcRadianCalc( Aradian, Sradian, Eradian))
			{
				ModeSeparate = TRUE;
			}
		}
		if ( ModeSeparate)
		{
			if ( Bradian > Sradian + 2 * pi)
			{
				Bradian -= 2 * pi;
			}
			if ( Aradian < Eradian - 2 * pi)
			{
				Aradian += 2 * pi;
			}
		}
		else
		{
			if ( Aradian > Eradian)
			{
				Aradian -= 2 * pi;
				Bradian -= 2 * pi;
			}
			else if ( Bradian < Sradian)
			{
				Aradian += 2 * pi;
				Bradian += 2 * pi;
			}
			if ( Aradian <= Sradian)
			{
				Aradian = Sradian;
			}
			else if ( Aradian > Eradian)
			{
				return;
			}
			if ( Bradian < Sradian)
			{
				return;
			}
			else if ( Bradian >= Eradian)
			{
				Bradian = Eradian;
			}
		}
	}
	double SeLength = DrawRadius * ( Bradian - Aradian);
	if ( left > 0 && right < 32767 && top < 0 && bottom > -32767 && SeLength >= 3)
	{
		int Sx, Sy, Ex, Ey;
		if ( ModeSeparate)
		{
			Sx = (int)( Cx + DrawRadius * cos( Sradian));
			Sy = (int)( Cy + DrawRadius * sin( Sradian));
			Ex = (int)( Cx + DrawRadius * cos( Bradian));
			Ey = (int)( Cy + DrawRadius * sin( Bradian));
			pDC->Arc( (int)left, (int)top, (int)right, (int)bottom, Sx, Sy, Ex, Ey);
			Sx = (int)( Cx + DrawRadius * cos( Aradian));
			Sy = (int)( Cy + DrawRadius * sin( Aradian));
			Ex = (int)( Cx + DrawRadius * cos( Eradian));
			Ey = (int)( Cy + DrawRadius * sin( Eradian));
			pDC->Arc( (int)left, (int)top, (int)right, (int)bottom, Sx, Sy, Ex, Ey);
		}
		else
		{
			Sx = (int)( Cx + DrawRadius * cos( Aradian));
			Sy = (int)( Cy + DrawRadius * sin( Aradian));
			Ex = (int)( Cx + DrawRadius * cos( Bradian));
			Ey = (int)( Cy + DrawRadius * sin( Bradian));
			pDC->Arc( (int)left, (int)top, (int)right, (int)bottom, Sx, Sy, Ex, Ey);
		}
	}
	else
	{
		double UnitRadian = 100 / DrawRadius;
		int SliceNum, Px, Py;
		if ( !ModeSeparate)
		{
			SliceNum = (int)( ( Bradian - Aradian) / UnitRadian) + 1;
			UnitRadian = ( Bradian - Aradian) / SliceNum;
			Px = (int)( Cx + DrawRadius * cos( Aradian));
			Py = (int)( Cy + DrawRadius * sin( Aradian));
			pDC->MoveTo( Px, Py);	
			for( double Rad = Aradian + UnitRadian; Rad < Bradian + UnitRadian / 2; Rad += UnitRadian)
			{
				Px = (int)( Cx + DrawRadius * cos( Rad));
				Py = (int)( Cy + DrawRadius * sin( Rad));
				pDC->LineTo( Px, Py);
			}
		}
		else
		{
			SliceNum = (int)( ( Bradian - Sradian) / UnitRadian) + 1;
			UnitRadian = ( Bradian - Sradian) / SliceNum;
			Px = (int)( Cx + DrawRadius * cos( Sradian));
			Py = (int)( Cy + DrawRadius * sin( Sradian));
			pDC->MoveTo( Px, Py);	
			for( double Rad = Sradian + UnitRadian; Rad < Bradian + UnitRadian / 2; Rad += UnitRadian)
			{
				Px = (int)( Cx + DrawRadius * cos( Rad));
				Py = (int)( Cy + DrawRadius * sin( Rad));
				pDC->LineTo( Px, Py);
			}
			SliceNum = (int)( ( Eradian - Aradian) / UnitRadian) + 1;
			UnitRadian = ( Eradian - Aradian) / SliceNum;
			Px = (int)( Cx + DrawRadius * cos( Aradian));
			Py = (int)( Cy + DrawRadius * sin( Aradian));
			pDC->MoveTo( Px, Py);	
			for( Rad = Aradian + UnitRadian; Rad < Eradian + UnitRadian / 2; Rad += UnitRadian)
			{
				Px = (int)( Cx + DrawRadius * cos( Rad));
				Py = (int)( Cy + DrawRadius * sin( Rad));
				pDC->LineTo( Px, Py);
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CArcs, CObject, 0)

CArcs::CArcs()
{
	m_Size = 0;
	m_IndexPen = 0;
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CConic, CObject, 0)
CConic::CConic()
{
	m_Flags = 1;
	m_Center = CPoint2D( 0, 0);
	m_Radius = 0;
	m_RatioRadius = 1;
	m_DegreeArc = CPoint2D( 0, 360);
	m_Degree = 0;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = CONIC_Normal;
};

void CConic::SetPointArrayDraw()
{
	//m_PointArrayDraw̃Zbg
	double pi = 3.141592653589793;
	double RadianRotation = m_Degree * pi / 180;
	double DegreeConic = m_DegreeArc.y - m_DegreeArc.x;
	double CountDevide = (double)(int)( DegreeConic / 5) + 1;		//ȉ~𒼐ߎ\镪px//m_AppDraw.m_DegreeUnitConic
	double RadianConic = DegreeConic * pi / 180;
	double RadianS = m_DegreeArc.x * pi / 180 - RadianRotation;
	double Radian;
	CPoint2D Point, PointR;
	m_PointArrayDraw.RemoveAll();
	for ( int ii = 0; ii <= CountDevide; ii++)
	{
		Radian = RadianS + RadianConic * ( ii / CountDevide);
		Point = CPoint2D( m_Center.x + m_Radius * cos( Radian), 
					m_Center.y + m_Radius * sin( Radian) * m_RatioRadius);
		PointR = CalcRotPointRadian( &Point, &m_Center, &RadianRotation);
		m_PointArrayDraw.Add( PointR);
	}
}

void CConic::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CConic::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	int Size = m_PointArrayDraw.GetSize();
	if ( Size <= 1)
	{
		ASSERT( FALSE);
		return;
	}
	CPoint2D PointA, PointB;
	for ( int ii = 0; ii < m_PointArrayDraw.GetSize() - 1; ii++)
	{
		PointA = m_PointArrayDraw.GetAt( ii);
		PointB = m_PointArrayDraw.GetAt( ii + 1);
		SortPoint( &PointA, &PointB);
		CLine Line( PointA, PointB);
		Line.Draw( pDC, pDocBase, pDocRatio, pDrawRect);
	}
}

void CConic::GetArea( double* pleft, double* pright, double* ptop, double* pbottom)
{
	//E㉺̒l𓾂
	*pleft = 0;
	*pright = 0;
	*ptop = 0;
	*pbottom = 0;
	int Size = m_PointArrayDraw.GetSize();
	if ( Size == 0) return;
	CPoint2D Point = m_PointArrayDraw.GetAt( 0);
	*pleft = Point.x;
	*pright = Point.x;
	*ptop = Point.y;
	*pbottom = Point.y;
	for ( int ii = 1; ii < m_PointArrayDraw.GetSize(); ii++)
	{
		Point = m_PointArrayDraw.GetAt( ii);
		*pleft = min( *pleft, Point.x);
		*pright = max( *pright, Point.x);
		*ptop = max( *ptop, Point.y);
		*pbottom = min( *pbottom, Point.y);
	}
}

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CConics, CObject, 0)

CConics::CConics()
{
	m_Size = 0;
	m_IndexPen = 0;
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CCurve, CObject, 0)

CCurve::CCurve()
{
	m_Flags = 1;
	m_TypeCurve = 0;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = CURVE_Normal;
};

void CCurve::SetPointArrayDraw()
{
	//m_PointArrayDraw̃Zbg
	if ( m_TypeCurve == CURVE_Scribble)
	{
		SetPointArrayDrawScribble();
	}
}

void CCurve::SetPointArrayDrawScribble()
{
	//m_PointArrayDraw̃Zbg
	m_PointArrayDraw.InsertAt( 0, &m_PointArray);
	m_PointArray.RemoveAll();
}

void CCurve::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D);
}

void CCurve::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect)
{
	int Size = m_PointArrayDraw.GetSize();
	if ( Size <= 1)
	{
		ASSERT( FALSE);
		return;
	}
	CPoint2D PointA, PointB;
	for ( int ii = 0; ii < m_PointArrayDraw.GetSize() - 1; ii++)
	{
		PointA = m_PointArrayDraw.GetAt( ii);
		PointB = m_PointArrayDraw.GetAt( ii + 1);
		SortPoint( &PointA, &PointB);
		CLine Line( PointA, PointB);
		Line.Draw( pDC, pDocBase, pDocRatio, pDrawRect);
	}
}

void CCurve::GetArea( double* pleft, double* pright, double* ptop, double* pbottom)
{
	//E㉺̒l𓾂
	*pleft = 0;
	*pright = 0;
	*ptop = 0;
	*pbottom = 0;
	int Size = m_PointArrayDraw.GetSize();
	if ( Size == 0) return;
	CPoint2D Point = m_PointArrayDraw.GetAt( 0);
	*pleft = Point.x;
	*pright = Point.x;
	*ptop = Point.y;
	*pbottom = Point.y;
	for ( int ii = 1; ii < m_PointArrayDraw.GetSize(); ii++)
	{
		Point = m_PointArrayDraw.GetAt( ii);
		*pleft = min( *pleft, Point.x);
		*pright = max( *pright, Point.x);
		*ptop = max( *ptop, Point.y);
		*pbottom = min( *pbottom, Point.y);
	}
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CCurves, CObject, 0)

CCurves::CCurves()
{
	m_Size = 0;
	m_IndexPen = 0;
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CText, CObject, 0)

CText::CText()
{
	m_Flags = 1;
	m_Color = 0;				//m_AppElem.m_PenColor; 
	m_TextAlign = TA_LEFT | TA_BOTTOM;
	m_Point = CPoint2D(0, 0);
	m_Spoint = CPoint2D( 0, 0);
	m_Epoint = CPoint2D( 0, 0);
	m_Swaped = FALSE;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_Type = TEXT_Normal;
};

void CText::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect, 
			LOGFONT* plogFont, int Mode, COLORREF Color, double RadianString, 
			double HeightText, double WidthText)
{
	CRect2D DrawRect2D( pDrawRect);
	Draw( pDC, pDocBase, pDocRatio, &DrawRect2D, plogFont, Mode, Color, 
											RadianString, HeightText, WidthText);
}

void CText::Draw( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect, 
			LOGFONT* plogFont, int Mode, COLORREF Color, double RadianString, 
			double HeightText, double WidthText)
{
	double LengthString = CalcDistance( &m_Spoint, &m_Epoint);
	LengthString *= *pDocRatio;
	CRect2D DrawRect = *pDrawRect;
	DrawRect.InflateRect( LengthString);	//020110//ʃI[o[̕`̈
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	COLORREF OldColor = pDC->SetTextColor( Color);
	if ( Mode == 1)		//plogFont->lfHeight <= -6//\[h
	{
		CPoint2D Off( 0, 0);
		UINT TextAlign = m_TextAlign;
		if ( TextAlign & TA_CENTERLINE)
		{
			TextAlign = (TextAlign & 7) | TA_BOTTOM;
			double Hx = -HeightText * sin( RadianString);
			double Hy = -HeightText * cos( RadianString);
			Off.x = -Hx / 2;	//Height<0
			Off.y = Hy / 2;
		}
		pDC->SetTextAlign( TextAlign);
		CPoint2D Point2D = m_Point.DataToDoc( pDocBase, pDocRatio);
		CPoint point = Point2D.ToLong();
		CPoint off = Off.ToLong();
		pDC->TextOut( point.x + off.x, point.y + off.y, m_String);
	}
	pDC->SetTextColor( OldColor);
}

void CText::DrawOption( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect* pDrawRect, int Mode, 
					   COLORREF Color, double HeightText, double WidthText, CTypeFont* pTypeFont)
{
	CRect2D DrawRect2D( pDrawRect);
	DrawOption( pDC, pDocBase, pDocRatio, &DrawRect2D, Mode, Color, HeightText, WidthText, pTypeFont);
}

void CText::DrawOption( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect2D, int Mode, 
					   COLORREF Color, double HeightText, double WidthText, CTypeFont* pTypeFont)
{
	double pi = 3.141592653589793;
	double RadianString = pTypeFont->m_Degree * pi / 180; 
	//W\
	if ( pTypeFont->m_FormString == FSTR_Strate &&
	     pTypeFont->m_Direction == DTEXT_Vert &&
	     pTypeFont->m_GapText != GTEXT_Randum &&
	     pTypeFont->m_SizeString != STEXT_Ratio)
	{
		ASSERT( !pTypeFont->m_LeftString);	//011228//WƏc͍̐ݒ͂Ȃ
		DrawVert( pDC, pDocBase, pDocRatio, pDrawRect2D, Mode, Color, HeightText, WidthText, pTypeFont);
	}
	else if ( pTypeFont->m_FormString == FSTR_Strate &&
			  ( pTypeFont->m_Direction == DTEXT_Horz || 
				pTypeFont->m_Direction == DTEXT_Slant ||
				pTypeFont->m_Direction == DTEXT_SlantLine) &&
			  pTypeFont->m_GapText != GTEXT_Randum &&
			  pTypeFont->m_SizeString != STEXT_Ratio)
	{
		DrawHorz( pDC, pDocBase, pDocRatio, pDrawRect2D, Mode, Color, HeightText, WidthText, pTypeFont);
	}
}

void CText::DrawVert( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect, 
	int Mode, COLORREF Color, double HeightText, double WidthText, CTypeFont* pTypeFont)
{
	//c
	//plogFont->lfEscapement͏cɐݒς݂Ƃ
	double pi = 3.141592653589793;
	double RadianString = pTypeFont->m_Degree * pi / 180; 
	double RatioString = pTypeFont->m_RatioGapText;
	BOOL LeftString = pTypeFont->m_LeftString;
	double LengthString = CalcDistance( &m_Spoint, &m_Epoint);
	LengthString *= *pDocRatio;
	CRect2D DrawRect = *pDrawRect;
	DrawRect.InflateRect( LengthString);	//020111//ʃI[o[̕`̈
	///////
	ASSERT( HeightText > 0 && WidthText >= 0);
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	COLORREF OldColor = pDC->SetTextColor( Color);
	if ( Mode == 1)		//plogFont->lfHeight <= -6//\[h
	{
		//TextOutVert()͔p̍Ŕzu
		//TextOutVert()͕̏(͉)Ŕzu	
		UINT TextAlign = m_TextAlign;
		UINT TextAlignDraw = TA_TOP + TA_CENTER;			//0+8
		if ( LeftString)
		{
			TextAlignDraw =	TA_BOTTOM + TA_CENTER;			//6+8 
		}
		pDC->SetTextAlign( TextAlignDraw);

		int CountString = m_String.GetLength();
		int CountTxt = 0;									//SpƔp̐̕FԃXy[X̐+1
		for ( int ii = 0; ii < m_String.GetLength(); ii++)
		{
			CString Text = m_String.Mid( ii, 2);
			if ( _ismbblead( Text[ 0]) && _ismbbtrail( Text[ 1]))	//Sp
			{
				CountTxt++;
				ii++;
			}
			else
			{
				CountTxt++;
			}
		}
		WORD CountPunkt = 0;
		BOOL BeforePunkt = FALSE;
		for ( ii = 0; ii < m_String.GetLength(); ii++)
		{
			char Char = m_String.GetAt( ii);
			if ( Char == '' || Char == '')
			{
				if ( !BeforePunkt)
				{
					CountPunkt++;
				}
				BeforePunkt = TRUE;
			}
			else
			{
				BeforePunkt = FALSE;
			}
		}
		CountTxt -= BeforePunkt;
		double Width = (double)pTypeFont->m_SizeTextBBBBB.cx / 10.0;
		double Hight = (double)pTypeFont->m_SizeTextBBBBB.cy / 10.0;
		CPoint2D PointBase = m_Point;
		//0.85//c̕␳
		double LengthStr = Hight * CountTxt * 0.85 + Width * RatioString * ( CountTxt - 1);
		double LengthX = LengthStr * cos( RadianString);
		double LengthY = LengthStr * sin( RadianString);
		if ( TextAlign & TA_RIGHT && !( TextAlign & 4))	//TA_RIGHT(2)
		{
			PointBase.x -= LengthX;
			PointBase.y -= LengthY;
		}
		else if ( TextAlign & TA_CENTER)				//TA_CENTER(6)//2܂
		{
			PointBase.x -= LengthX / 2;
			PointBase.y -= LengthY / 2;
		}
		double OffVertY = Width * cos( RadianString);
		double OffVertX = Width * sin( -RadianString);
		PointBase.x += OffVertX;
		PointBase.y += OffVertY;
		//0.85//c̕␳
		double OffRatioTextHeightX = Hight * cos( RadianString) * ( 1 - 0.85) / 2;
		double OffRatioTextHeightY = Hight * sin( RadianString) * ( 1 - 0.85) / 2;
		PointBase.x -= OffRatioTextHeightX;
		PointBase.y -= OffRatioTextHeightY;
		CPoint2D Off( 0, 0);				//TextAlignɂzu_ƕ`_̃ItZbg
		CPoint2D Point2D = PointBase.DataToDoc( pDocBase, pDocRatio);
		CPoint BasePoint = Point2D.ToLong();
		CPoint off = Off.ToLong();
		BasePoint += off;
		///////
		CPoint UnitOffText;					//ꕶ̃ItZbg
		CPoint UnitOffGap;					//ԊũItZbg
		CPoint UnitOffUni;					//p̒SɑSp̒S𑵂ItZbg
		CPoint UnitOffSuff;					//t_̃ItZbg
		CPoint UnitOffPunct;				//pǓ_(punctuation)̃ItZbg
		CPoint UnitOffPunctUni;				//SpǓ_(punctuation)̃ItZbg
		GetOffVert( RadianString, HeightText, WidthText, RatioString, &UnitOffText, &UnitOffGap,
			&UnitOffUni, &UnitOffSuff, &UnitOffPunct, &UnitOffPunctUni);
		TextOutVert( pDC, BasePoint, UnitOffText, UnitOffGap,
			UnitOffUni, UnitOffSuff, UnitOffPunct, UnitOffPunctUni);
	}
	pDC->SetTextColor( OldColor);
}

void CText::DrawHorz( CDC* pDC, CPoint2D* pDocBase, double* pDocRatio, CRect2D* pDrawRect, int Mode, 
					 COLORREF Color, double HeightText, double WidthText, CTypeFont* pTypeFont)
{
	//ʕ\//䗦//XΕ
	double pi = 3.141592653589793;
	double RadianString = pTypeFont->m_Degree * pi / 180; 
	double RatioString = pTypeFont->m_RatioGapText;
	BOOL LeftString = pTypeFont->m_LeftString;
	double LengthString = CalcDistance( &m_Spoint, &m_Epoint);
	LengthString *= *pDocRatio;
	CRect2D DrawRect = *pDrawRect;
	DrawRect.InflateRect( LengthString);
	///////
	ASSERT( HeightText > 0 && WidthText >= 0);
	CPoint2D Spoint = m_Spoint.DataToDoc( pDocBase, pDocRatio);
	CPoint2D Epoint = m_Epoint.DataToDoc( pDocBase, pDocRatio);
	BOOL InnerRect = FALSE;
	COLORREF OldColor = pDC->SetTextColor( Color);
	if ( Mode == 1)									//plogFont->lfHeight <= -6//\[h
	{
		CPoint2D Off( 0, 0);						//CenterBottomɈړOffset
		UINT TextAlign = m_TextAlign;
		if ( TextAlign & TA_CENTERLINE)
		{
			TextAlign = (TextAlign & 7) | TA_BOTTOM;
			//RadianStringCCW
			double Hx = HeightText * sin( RadianString);
			double Hy = -HeightText * cos( RadianString);
			Off.x = Hx / 2;							//HeightText >0
			Off.y = Hy / 2;
		}
		UINT TextAlignDraw = TA_LEFT + TA_TOP;		//TA_LEFT(0) + TA_TOP(0)
		if ( LeftString)
		{
			TextAlignDraw =	TA_RIGHT + TA_TOP;		//TA_RIGHT(2) + TA_TOP(0) 
		}
		if ( TextAlign & TA_BOTTOM)					//8
		{
			TextAlignDraw += TA_BOTTOM;
		}
		else if ( TextAlign & TA_CENTERLINE)		//32
		{
			TextAlignDraw += TA_CENTERLINE;
		}
		else if ( TextAlign & TA_TOP)				//0
		{
			TextAlignDraw += TA_TOP;
		}
		pDC->SetTextAlign( TextAlignDraw);
		int CountString = m_String.GetLength();
		int CountTxt = 0;							//SpƔp̐̕
		for ( int ii = 0; ii < m_String.GetLength(); ii++)
		{
			CString Text = m_String.Mid( ii, 2);
			if ( _ismbblead( Text[ 0]) && _ismbbtrail( Text[ 1]))	//Sp
			{
				CountTxt++;
				ii++;
			}
			else
			{
				CountTxt++;
			}
		}
		WORD CountPunkt = 0;
		BOOL BeforePunkt = FALSE;
		for ( ii = 0; ii < m_String.GetLength(); ii++)
		{
			char Char = m_String.GetAt( ii);
			if ( Char == '' || Char == '')
			{
				if ( !BeforePunkt)
				{
					CountPunkt++;
				}
				BeforePunkt = TRUE;
			}
			else
			{
				BeforePunkt = FALSE;
			}
		}
		CountString -= BeforePunkt;
		CountTxt -= BeforePunkt;
		double Width = (double)pTypeFont->m_SizeTextBBBBB.cx / 10.0;
		CPoint2D PointBase = m_Point;
		double LengthStr = Width * CountString + Width * RatioString * ( CountTxt - 1);
		double LengthX = LengthStr * cos( RadianString);
		double LengthY = LengthStr * sin( RadianString);
		if ( LeftString)
		{
			LengthX *= -1;
		}
		if ( TextAlign & TA_RIGHT && !( TextAlign & 4))		//TA_RIGHT(2)
		{
			PointBase.x -= LengthX;
			PointBase.y -= LengthY;
		}
		else if ( TextAlign & TA_CENTER)					//TA_CENTER(6)//2܂
		{
			PointBase.x -= LengthX / 2;
			PointBase.y -= LengthY / 2;
		}
		CPoint2D Point2D = PointBase.DataToDoc( pDocBase, pDocRatio);
		CPoint BasePoint = Point2D.ToLong();
		CPoint off = Off.ToLong();
		BasePoint += off;
		///////
		CPoint UnitOffText;									//ꕶ̃ItZbg
		CPoint UnitOffGap;									//ԊũItZbg
		GetOffHorz( RadianString, HeightText, WidthText, RatioString, LeftString,
			&UnitOffText, &UnitOffGap);
		CPoint OffText( 0, 0);								//ɂzũItZbg
		CPoint OffGap( 0, 0);								//ԊuɂzũItZbg
		TextOutHorz( pDC, BasePoint, UnitOffText, UnitOffGap, LeftString);
	}
	pDC->SetTextColor( OldColor);
}

void CText::GetOffVert( double RadianString, double HeightText, double WidthText, double RatioString,
		CPoint* pUnitOffText, CPoint* pUnitOffGap, CPoint* pUnitOffUni, 
		CPoint* pUnitOffSuff, CPoint* pUnitOffPunct, CPoint* pUnitOffPunctUni)
{
	//WidthTextDocRatio𔽉f(SetNewFont()ʂ)l
	CPoint2D UnitOffW2D( -WidthText * sin( RadianString), WidthText * cos( RadianString));
	CPoint2D UnitOffH2D( HeightText * cos( RadianString), HeightText * sin( RadianString));
	CPoint2D UnitOffUni2D = UnitOffW2D;			//p̒SɑSp̒S𑵂ItZbg
	UnitOffUni2D /= -2;
	*pUnitOffUni = UnitOffUni2D.ToLong();
	CPoint2D UnitOffText2D = UnitOffH2D;		//ꕶ̃ItZbg
	//0.85//c̕␳
	UnitOffText2D *= 0.85;
	if ( RatioString < 0)
	{
		UnitOffText2D *= -1;
	}
	*pUnitOffText = UnitOffText2D.ToLong();
	//ԊũItZbg
	CPoint2D UnitOffGap2D = UnitOffH2D;
	ASSERT( HeightText != 0);
	UnitOffGap2D /= HeightText;
	UnitOffGap2D *= WidthText;
	UnitOffGap2D *= RatioString;				//Ԋu̔pɑ΂䗦
	*pUnitOffGap = UnitOffGap2D.ToLong();
	CPoint2D UnitOffSuff2D = UnitOffW2D;		//t_̃ItZbg
	UnitOffSuff2D *= 0.625;						//0.625//5/8//cł߂̉ItZbg
	*pUnitOffSuff = UnitOffSuff2D.ToLong();
	CPoint2D UnitOffPunct2D = UnitOffW2D;		//pǓ_(punctuation)̃ItZbg
	CPoint2D UnitOffPunct2DH = UnitOffH2D;
	*pUnitOffPunct = UnitOffPunct2D.ToLong();
	CPoint2D UnitOffPunct2DUni = UnitOffW2D;	//SpǓ_(punctuation)̃ItZbg
	UnitOffPunct2DUni *= 2;
	CPoint2D UnitOffPunct2DHUni = UnitOffH2D;
	UnitOffPunct2DUni *= 0.7;					//0.7//cSp̡̉ItZbg
	UnitOffPunct2DHUni *= 0.3;					//0.3//cł̡̏cItZbg
	UnitOffPunct2DUni += UnitOffPunct2DHUni;
	*pUnitOffPunctUni = UnitOffPunct2DUni.ToLong();
}

void CText::TextOutVert( CDC* pDC, CPoint PointBase, CPoint UnitOffText, CPoint UnitOffGap,
		CPoint UnitOffUni, CPoint UnitOffSuff, CPoint UnitOffPunct, CPoint UnitOffPunctUni)
{
	//񒆐S̔zu_蔼pƕƕԊuƑSpƓꕶ̕␳Ȃ當o͂
	CPoint PointPut = PointBase;
	BOOL BeforeSuff = FALSE;
	for ( int ii = 0; ii < m_String.GetLength(); ii++)
	{
		CString TextAlone;
		if ( ii < m_String.GetLength() - 1)
		{
			TextAlone = m_String.Mid( ii, 2);
			if ( _ismbblead( TextAlone[ 0]) && _ismbbtrail( TextAlone[ 1]))	//
			{
				if ( TextAlone == "B" || TextAlone == "A")
				{
					PointPut += UnitOffUni;
					PointPut += UnitOffPunctUni;
					pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
					PointPut -= UnitOffPunctUni;		//Sɖ߂
					PointPut -= UnitOffUni;
					PointPut += UnitOffText;			//Ǔ_̌ɏc]T
				}
				else if ( TextAlone == "J" || TextAlone == "K")
				{
					PointPut += UnitOffPunctUni;
					pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
					PointPut -= UnitOffPunctUni;
				}
				else									//ʏ핶//Sp
				{
					pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
				}
				PointPut += UnitOffText;
				PointPut += UnitOffGap;
				BeforeSuff = FALSE;
				ii++;
				continue;
			}
		}
		int ModeSuffix = 0;
		char Char = m_String.GetAt( ii);
		TextAlone = Char;
		if ( TextAlone == "" || TextAlone == "") ModeSuffix = 1;
		else if ( TextAlone == "" || TextAlone == "") ModeSuffix = 2;
		if ( ModeSuffix == 1)
		{
			if ( BeforeSuff)
			{
				PointPut += UnitOffPunct;
			}
			else
			{
				PointPut -= UnitOffText;
				PointPut -= UnitOffGap;
				PointPut += UnitOffPunct;
			}
		}
		else if ( ModeSuffix == 2)
		{
			PointPut += UnitOffPunct;
			PointPut -= UnitOffGap;
		}
		pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
		if ( ModeSuffix == 1)
		{
			PointPut -= UnitOffPunct;
		}
		else if ( ModeSuffix == 2)
		{
			PointPut -= UnitOffPunct;
		}
		PointPut += UnitOffText;
		PointPut += UnitOffGap;
		BeforeSuff = FALSE;
		if ( ModeSuffix == 1)
		{
			BeforeSuff = TRUE;
		}
	}
}

void CText::TextOutVertDammy( CPoint PointBase, CPoint UnitOffText, CPoint UnitOffGap,
		CPoint UnitOffUni, CPoint UnitOffSuff, CPoint UnitOffPunct, CPoint UnitOffPunctUni, CPoint* pPointPut)
{
	//TextOutVert()TextOut()
	*pPointPut = PointBase;
	BOOL BeforeSuff = FALSE;
	for ( int ii = 0; ii < m_String.GetLength(); ii++)
	{
		CString TextAlone;
		if ( ii < m_String.GetLength() - 1)
		{
			TextAlone = m_String.Mid( ii, 2);
			if ( _ismbblead( TextAlone[ 0]) && _ismbbtrail( TextAlone[ 1]))	//
			{
				if ( ii != 0)
				{
					*pPointPut += UnitOffGap;
				}
				if ( TextAlone == "B" || TextAlone == "A")
				{
					*pPointPut += UnitOffText;								//Ǔ_̌ɏc]T
				}
				else
				{
					*pPointPut += UnitOffText;
				}
				BeforeSuff = FALSE;
				ii++;
				continue;
			}
		}
		int ModeSuffix = 0;
		char Char = m_String.GetAt( ii);
		TextAlone = Char;
		if ( TextAlone == "" || TextAlone == "") ModeSuffix = 1;
		else if ( TextAlone == "" || TextAlone == "") ModeSuffix = 2;
		if ( ModeSuffix == 1)
		{
			if ( BeforeSuff)
			{
				if ( ii != 0)
				{
					*pPointPut += UnitOffGap;
				}
				*pPointPut += UnitOffText;
			}
		}
		else if ( ModeSuffix == 2)
		{
			if ( ii != 0)
			{
				*pPointPut += UnitOffGap;
			}
		}
		else
		{
			if ( ii != 0)
			{
				*pPointPut += UnitOffGap;
			}
			*pPointPut += UnitOffText;
		}
		if ( ModeSuffix == 1)
		{
		}
		else if ( ModeSuffix == 2)	
		{
			*pPointPut += UnitOffText;										//Ǔ_̌ɏc]T
		}
		BeforeSuff = FALSE;
		if ( ModeSuffix == 1)
		{
			BeforeSuff = TRUE;
		}
	}
}

void CText::GetOffHorz( double RadianString, double HeightText, double WidthText, double RatioString,
			BOOL LeftString, CPoint* pUnitOffText, CPoint* pUnitOffGap)
{
	//WidthTextDocRatio𔽉f(SetNewFont()ʂ)l
	CPoint2D UnitOffW2D( WidthText * cos( RadianString), WidthText * sin( RadianString));
	CPoint2D UnitOffText2D = UnitOffW2D;	//ꕶ̃ItZbg
	if ( LeftString)
	{
		UnitOffText2D *= -1;
	}
	*pUnitOffText = UnitOffText2D.ToLong();
	CPoint2D UnitOffGap2D = UnitOffW2D;		//ԊũItZbg
	UnitOffGap2D *= RatioString;			//Ԋu̔pɑ΂䗦
	if ( LeftString)
	{
		UnitOffGap2D *= -1;
	}
	*pUnitOffGap = UnitOffGap2D.ToLong();
}

void CText::TextOutHorz( CDC* pDC, CPoint BasePoint, CPoint UnitOffText, CPoint UnitOffGap, BOOL LeftString)
{
	CPoint PointPut = BasePoint;
	BOOL BeforeSuff = FALSE;
	for ( int ii = 0; ii < m_String.GetLength(); ii++)
	{
		CString TextAlone;
		if ( ii < m_String.GetLength() - 1)
		{
			TextAlone = m_String.Mid( ii, 2);
			if ( _ismbblead( TextAlone[ 0]) && _ismbbtrail( TextAlone[ 1]))	//
			{
				pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
				PointPut += UnitOffText;
				PointPut += UnitOffText;
				PointPut += UnitOffGap;
				ii++;
				continue;
			}
		}
		int ModeSuffix = 0;
		char Char = m_String.GetAt( ii);
		if ( Char == '' || Char == '') ModeSuffix = 1;			//t_
		else if ( Char == '' || Char == '') ModeSuffix = 2;
			if ( ModeSuffix == 1)
			{
				PointPut -= UnitOffGap;
			}
		TextAlone = Char;
		pDC->TextOut( PointPut.x, PointPut.y, TextAlone);
		PointPut += UnitOffText;
		PointPut += UnitOffGap;
	}
}

void CText::TextOutHorzDammy( CPoint BasePoint, CPoint UnitOffText, CPoint UnitOffGap,
			BOOL LeftString, CPoint* pPointPut)
{
	//ŏI_pPointPut𓾂
	//TextOutHorz()TextOut()
	*pPointPut = BasePoint;
	if ( LeftString)
	{
		*pPointPut += UnitOffText;				//zu_𕶎̉E[ɂ
		CString TextTop = m_String.Mid( 0, 2);
		if ( _ismbblead( TextTop[ 0]) && _ismbbtrail( TextTop[ 1]))		//Sp
		{
			*pPointPut += UnitOffText;			//zu_𔼊p炷
		}
	}
	BOOL BeforeSuff = FALSE;
	BOOL BeforeHalf = FALSE;
	for ( int ii = 0; ii < m_String.GetLength(); ii++)
	{
		CString TextAlone;
		if ( ii < m_String.GetLength() - 1)
		{
			TextAlone = m_String.Mid( ii, 2);
			if ( _ismbblead( TextAlone[ 0]) && _ismbbtrail( TextAlone[ 1]))	//
			{
				if ( ii != 0)
				{
					if ( LeftString && BeforeHalf)
					{
						*pPointPut += UnitOffText;
						*pPointPut += UnitOffText;
						*pPointPut += UnitOffGap;
					}
					else
					{
						*pPointPut += UnitOffText;
						*pPointPut += UnitOffGap;
					}
					BeforeHalf = FALSE;

				}
				*pPointPut += UnitOffText;
				BeforeSuff = FALSE;
				ii++;
				continue;
			}
		}
		int ModeSuffix = 0;
		char Char = m_String.GetAt( ii);
		if ( Char == '' || Char == '') ModeSuffix = 1;		//t_
		else if ( Char == '' || Char == '') ModeSuffix = 2;
		if ( ii != 0)
		{
			if ( ModeSuffix == 1)
			{
				if ( BeforeSuff)
				{
					*pPointPut += UnitOffText;
					*pPointPut += UnitOffGap;
				}
				else if ( LeftString)
				{
					*pPointPut -= UnitOffText;
				}
				else
				{
					*pPointPut += UnitOffText;
				}
			}
			else if ( ModeSuffix == 2)
			{
				*pPointPut += UnitOffText;
				*pPointPut += UnitOffGap;
			}
			else
			{
				*pPointPut += UnitOffText;
				*pPointPut += UnitOffGap;
			}
		}
		TextAlone = Char;
		BeforeHalf = TRUE;
		if ( ii != 0)
		{
			if ( ModeSuffix == 1)
			{
				if ( !BeforeSuff)
				{
					if ( LeftString)
					{
						*pPointPut += UnitOffText;			//̈ʒuɖ߂
					}
					else
					{
						*pPointPut -= UnitOffText;
					}
				}
				BeforeSuff = TRUE;
			}
			else
			{
				BeforeSuff = FALSE;
			}
		}
	}
	if ( LeftString)
	{
		if ( !BeforeHalf)
		{
			*pPointPut -= UnitOffText;
		}
	}
	else
	{
		*pPointPut += UnitOffText;
	}
}

/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CTexts, CObject, 0)

CTexts::CTexts()
{
	m_Size = 0;
	m_IndexFont = 0;
}

CTexts::~CTexts()
{
}

///////////////////////////////////////////////////////////////////////////////
