// OursObj.cpp - implementation for Oursing objects

#include "stdafx.h"
#include "Orw.h"
#include "OrwDoc.h"
#include "OrwView.h"
#include "OrwObj.h"
#include "OrwCalc.h"
#include "OrwCntrItem.h"
//////////////////////////////////////////////////////////
extern COrwApp* pApp;
//////////////////////////////////////////////////////////

IMPLEMENT_SERIAL(COursObj, CObject, 0)

COursObj::COursObj()
{
	m_pDocument = NULL;
	m_Flags = 1;
	m_IndexLayer = 0;
	m_IndexGroup = -1;
	m_IndexLayerOut = 0;
	m_IndexGroupOut = -1;
}

COursObj::~COursObj()
{
}

CRect COursObj::SetOursRect( COrwView* pView, BOOL* pOverd)
{
	//Object̕\TCYCRectԂ
	*pOverd = FALSE;
	CPoint2D DocBase = pView->m_DocBase;
	double DocRatio = pView->m_DocRatio;;
	CPoint2D LeftTopObjDoc = m_LeftTopObj.DataToDoc( &DocBase, &DocRatio);
	CPoint2D RightBottomObjDoc = m_RightBottomObj.DataToDoc( &DocBase, &DocRatio);
	if ( LeftTopObjDoc.x < 0)
	{
		*pOverd = TRUE;
		LeftTopObjDoc.x = 0;
	}
	if ( LeftTopObjDoc.y > 0)
	{
		*pOverd = TRUE;
		LeftTopObjDoc.y = 0;
	}
	if ( RightBottomObjDoc.x > 32000)
	{
		*pOverd = TRUE;
		RightBottomObjDoc.x = 32000;
	}
	if ( RightBottomObjDoc.y < -32000)
	{
		*pOverd = TRUE;
		RightBottomObjDoc.y = -32000;
	}
	//`łg嗦E܂ŏグ
	double Width = RightBottomObjDoc.x - LeftTopObjDoc.x;
	double Hight = RightBottomObjDoc.y - LeftTopObjDoc.y;
	if ( Width > 16500) *pOverd = TRUE;
	if ( Hight < -16500) *pOverd = TRUE;
	CRect rect; 
	rect.left = (int)LeftTopObjDoc.x;
	rect.top = (int)LeftTopObjDoc.y;
	rect.right = (int)RightBottomObjDoc.x;
	rect.bottom = (int)RightBottomObjDoc.y;
	return rect;
}

void COursObj::Serialize(CArchive& ar)
{
	CObject::Serialize( ar);
	if (ar.IsStoring())
	{
		//gpLayer,GroupPassIndexo
		ar.Write( &m_IndexLayerOut, sizeof( WORD));
		ar.Write( &m_IndexGroupOut, sizeof( short int));
		ar.Write( &m_LeftTopObj.x, sizeof( double));
		ar.Write( &m_LeftTopObj.y, sizeof( double));
		ar.Write( &m_RightBottomObj.x, sizeof( double));
		ar.Write( &m_RightBottomObj.y, sizeof( double));
		ar.Write( &m_Flags, sizeof( unsigned char));
	}
	else
	{
		//get the document back pointer from the archive
		ar.Read( &m_IndexLayer, sizeof( WORD));
		ar.Read( &m_IndexGroup, sizeof( short int));
		ar.Read( &m_LeftTopObj.x, sizeof( double));
		ar.Read( &m_LeftTopObj.y, sizeof( double));
		ar.Read( &m_RightBottomObj.x, sizeof( double));
		ar.Read( &m_RightBottomObj.y, sizeof( double));
		m_pDocument = (COrwDoc*)ar.m_pDocument;
		ar.Read( &m_Flags, sizeof( unsigned char));
		m_IndexLayerOut = m_IndexLayer;
		m_IndexGroupOut = m_IndexGroup;
	}
}

#ifdef _DEBUG
void COursObj::AssertValid()
{
}
#endif

////////////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(COursOleObj, COursObj, 0)

BOOL COursOleObj::c_bShowItems = FALSE;		//Itemg̕\Ȃ

COursOleObj::COursOleObj() : m_extent(0,0)
{
}

COursOleObj::COursOleObj( COursOleObj* pObj)
{
	m_RightBottomObj = pObj->m_RightBottomObj;	//x+ y-
	m_Ratio = pObj->m_Ratio;					//c//Ɨp
	m_LeftTopObj = pObj->m_LeftTopObj;			//datazuʒu
	m_pDocument = pObj->m_pDocument;
	m_Flags = pObj->m_Flags;		//1(display,searchable,editable) 2(display) 4(hide) 8(deleted) 16(block) 128(changed:instance)
	m_IndexLayer = pObj->m_IndexLayer;
	m_IndexGroup = pObj->m_IndexGroup;			//GroupIndex
	m_IndexLayerOut = pObj->m_IndexLayerOut;	//OursFile,OlełSerialize()oIndex
	m_IndexGroupOut = pObj->m_IndexGroupOut;	//OursFile,OlełSerialize()oIndex
	c_bShowItems = pObj->c_bShowItems;			//Itemg̕\(TRUE)//
	m_IndexItem = pObj->m_IndexItem;
	m_extent.cx = pObj->m_extent.cx;
	m_extent.cy = pObj->m_extent.cy;
}

COursOleObj::~COursOleObj()
{
}

void COursOleObj::Serialize( CArchive& ar)
{
	ASSERT_VALID( this);

	COursObj::Serialize( ar);

	if (ar.IsStoring())
	{
		ar << m_extent;
		ar.Write( &m_IndexItem, sizeof( int));
	}
	else
	{
		ar >> m_extent;
		ar.Read( &m_IndexItem, sizeof( int));
	}
}

void COursOleObj::Draw( COrwView* pView, CDC* pDC, CRect* pRectClip)
{
	ASSERT_VALID( this);
	ASSERT( m_IndexItem >= 0 && m_IndexItem < m_pDocument->m_ItemArray.GetSize());
	if ( m_IndexItem < 0 || m_IndexItem >= m_pDocument->m_ItemArray.GetSize())
	{
		return;
	}
	COursCntrItem* pItem = m_pDocument->m_ItemArray.GetAt( m_IndexItem);
	if ( pItem != NULL)
	{
#ifdef _DEBUG
		OLE_OBJTYPE RetOO = pItem->GetType();
		if ( RetOO == OT_LINK)			//NACe
		{
			int AA = 0;
		}
		else if ( RetOO == OT_EMBEDDED)	//ߍ݃ACe
		{
			int AA = 0;
		}
		else if ( RetOO == OT_STATIC)	//ÓIACe
		{
			int AA = 0;
		}
		HGLOBAL RetHG = pItem->GetIconicMetafile();
		if ( RetHG == NULL)
		{
			int AA = 0;
		}
#endif
		//draw the OLE item itself
		BOOL Overd;
		CRect Position = SetOursRect( pView, &Overd);
		//DVASPECT_CONTENT(1) DVASPECT_THUMBNAIL(2) DVASPECT_ICON(4) DVASPECT_DOCPRINT(8)
		BOOL DrewItem;
		if ( !Overd)
		{
			//Mfc\src\Olecli1.cpp
			DrewItem = pItem->Draw( pDC, Position, DVASPECT_CONTENT);		//CAD Line \
		}
		//don't draw tracker in print preview or on printer
		if ( !pDC->IsPrinting())
		{
			// use a CRectTracker to draw the standard effects
			CRectTracker tracker;
			tracker.m_rect = Position;
			pDC->LPtoDP( tracker.m_rect);
			if ( c_bShowItems)
			{
				//put correct border depending on item type
				if ( pItem->GetType() == OT_LINK) tracker.m_nStyle |= CRectTracker::dottedLine;
				else tracker.m_nStyle |= CRectTracker::solidLine;
			}
			//put hatching over the item if it is currently open
			if ( pItem->GetItemState() == COleClientItem::openState ||
				 pItem->GetItemState() == COleClientItem::activeUIState)
			{
				tracker.m_nStyle |= CRectTracker::hatchInside;
			}
			CRect2D RectTracker( m_LeftTopObj.x, m_LeftTopObj.y, m_RightBottomObj.x, m_RightBottomObj.y);
			RectTracker.NormalizeRect();
			RectTracker.Draw( pDC, &pView->m_DocBase, &pView->m_DocRatio, pRectClip);
		}
	}
}

void COursOleObj::SetItemBackPointerWork()
{
}

///////////////////////////////////////////////////////////////////////////////
