// OrwObj.h - interface for COursObj and derivatives

#ifndef __OURSOBJ_H__
#define __OURSOBJ_H__

class COrwView;
class COrwDoc;
class COursCntrItem;
class COursOleObj;

/////////////////////////////////////////////////////////////////////////////
// special 'list' class for this application (requires afxtempl.h)
typedef CTypedPtrArray<CObArray, COursOleObj*> COursObjArray;
typedef CTypedPtrArray<CObArray, COursCntrItem*> COursItemArray;
/////////////////////////////////////////////////////////////////////////////
//COursObj - base class for all 'Oursable objects'

class COursObj : public CObject
{
	//COursOleObj̊{class

protected:
	DECLARE_SERIAL( COursObj);
	COursObj();

public:
	CPoint2D m_RightBottomObj;						//x+ y-
	double m_Ratio;									//c//Ɨp
	CPoint2D m_LeftTopObj;							//datazuʒu
	COrwDoc* m_pDocument;
	unsigned char m_Flags;							//1(display,searchable,editable) 2(display) 4(hide) 8(deleted) 16(block) 128(changed:instance)
	WORD m_IndexLayer;
	short int m_IndexGroup;							//GroupIndex
	WORD m_IndexLayerOut;							//OursFile,OlełSerialize()oIndex
	short int m_IndexGroupOut;						//OursFile,OlełSerialize()oIndex
	CRect SetOursRect( COrwView*, BOOL*);			//Object̕\TCYCRectԂ
	CRect SetOursRect( CPoint2D*, double*, BOOL*);	//Object̕\TCYCRectԂ
	enum TrackerState { normal, selected, active };

public:
	virtual ~COursObj();
	virtual void Serialize( CArchive& ar);

#ifdef _DEBUG
	void AssertValid();
#endif

};

////////////////////////////////////////////////////////////////////////
class COursItem;    //COleClientItem derived class

class COursOleObj : public COursObj
{
	//COursObj̔hclass//COursDoc::m_ObjArrayɓo^

protected:
	DECLARE_SERIAL( COursOleObj);
	COursOleObj();
	COursOleObj( COursOleObj*);


public:
	virtual void Serialize( CArchive& ar);
	void Draw( COrwView* pView, CDC* pDC, CRect*);
	virtual ~COursOleObj();
	void SetItemBackPointerWork();					//COursCntrItem::m_ObjArraydȂZbg
	static BOOL c_bShowItems;						//Itemg̕\(TRUE)
	int m_IndexItem;								//CopyŋItemƂ
	CSize m_extent;									//current extent is tracked separate from scaled position
};

#endif // __OURSOBJ_H__



