// OrwView.cpp : COrwView NX̓̒`s܂B

#include "stdafx.h"
#include "Orw.h"
#include "OrwDoc.h"
#include "OrwView.h"
#include "OrwFile.h"
#include "OrwCntrItem.h"

#include <math.h>	//for fabs()

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
extern COrwApp* pApp;
//////////////////////////////////////////////////////////
// COrwView

IMPLEMENT_DYNCREATE(COrwView, CView)

BEGIN_MESSAGE_MAP(COrwView, CView)
	//{{AFX_MSG_MAP(COrwView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COrwView NX̍\z/

COrwView::COrwView()
{
	m_bActive = FALSE;
	m_pDoc = NULL;
	m_DocBase = CPoint2D( -16000, 16000);
	m_DocRatio = 1;					//ʂ͌C[WƂ
	m_RectClient = CRect( 0, 0, 0, 0);
	m_ScrollPoint = CPoint( 0, 0);
	SetScrollSizes( MM_LOMETRIC, CSize( 32000, 32000));
	m_pNewPen = NULL;
	m_pOldPen = NULL;
	m_pNewFont = NULL;
	m_pOldFont = NULL;
	m_FirstView = TRUE;
}

COrwView::~COrwView()
{
	if ( pApp->m_pActiveView == this)
	{
		pApp->m_pActiveView = NULL;
	}
}

BOOL COrwView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

BOOL COrwView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	char WndClassName[ 256];
	strcpy( WndClassName, pApp->m_StringWndClass);
	BOOL Ret = CWnd::Create( WndClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	m_pDoc = GetDocument();
	ASSERT( m_pDoc != NULL);
	return Ret;
}
/////////////////////////////////////////////////////////////////////////////
// COrwView NX̐ff

#ifdef _DEBUG
void COrwView::AssertValid() const
{
	CView::AssertValid();
}

void COrwView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COrwDoc* COrwView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COrwDoc)));
	return (COrwDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

void COrwView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if ( bActivate) 
	{
		pApp->m_pActiveView = this;
		pApp->m_pActiveView->m_bActive = TRUE;
	}
	CScrollView::OnActivateView(bActivate, pActivateView, pDeactiveView);
	if ( m_bActive != bActivate)
	{
		if ( bActivate) m_bActive = bActivate;  // if becoming active update as if active
		m_bActive = bActivate;
	}
}

void COrwView::OnInitialUpdate() 
{
	ASSERT( m_pDoc != NULL);
	SetCenterViewParam();
	InitScrollSizes();
	CView::OnInitialUpdate();
}

void COrwView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	CScrollView::OnPrepareDC(pDC, pInfo);
}

int COrwView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate( lpCreateStruct) == -1) return -1;
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	return 0;
}

void COrwView::OnDestroy() 
{
	CScrollView::OnDestroy();
	//deactivate the inplace active item on this view
}

void COrwView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
}

void COrwView::OnSize(UINT nType, int cx, int cy) 
{
	//VKEBhEŃEBhE̊e(XN[o[ܔetc.)\zŉxĂ΂
	//ŌɌĂ΂̂NCAg̈
	//TCYύX̓NCAg̈ňĂ΂
	//̌OnDraw()֍sm_RectClientݒ肷
	//cx,cy>0//foCXP
	CRect RectClient( 0, 0, cx, cy);
	CClientDC dc( this);
	OnPrepareDC( &dc);
	dc.DPtoLP( &RectClient);
	if ( m_FirstView)
	{
		m_RectClient = RectClient;
		if ( cx != 0 && cy != 0)
		{
			double Sx = m_pDoc->m_DataRect2D.left;
			double Sy = m_pDoc->m_DataRect2D.top;
			double Ex = m_pDoc->m_DataRect2D.right;
			double Ey = m_pDoc->m_DataRect2D.bottom;
			double Dx = Ex - Sx;
			double Dy = Ey - Sy;
			double NewDocRatio;
			if ( Dx == 0 && Dy == 0) NewDocRatio = 1;
			else if ( Dx == 0) NewDocRatio = m_RectClient.Height() / Dy;
			else if ( Dy == 0) NewDocRatio = m_RectClient.Width() / Dx;
			else NewDocRatio = min( m_RectClient.Width() / Dx, m_RectClient.Height() / Dy);
			CPoint2D NewDocBase;
			if ( SetDocBase( &NewDocBase, &NewDocRatio, 3))
			{
				SetBase( NewDocBase, TRUE);
				m_DocRatio = NewDocRatio;
			}
		}
		SetCenterViewParam();
		ScrollToPosition( m_ScrollPoint);
	}
	CView::OnSize( nType, cx, cy);
}

void COrwView::OnFileSave() 
{
	AfxMessageBox( "T|[gĂ܂", MB_OK, 0);
}

void COrwView::OnFilePrint() 
{
	AfxMessageBox( "T|[gĂ܂", MB_OK, 0);
}

void COrwView::OnFilePrintPreview() 
{
	AfxMessageBox( "T|[gĂ܂", MB_OK, 0);
}

void COrwView::OnFilePrintSetup() 
{
	AfxMessageBox( "T|[gĂ܂", MB_OK, 0);
}

/////////////////////////////////////////////////////////////////////////////
// COrwView NX̕`
/////////////////////////////////////////////////////////////////////////////

void COrwView::OnDraw(CDC* pDC)
{
	double pi = 3.141592653589793;
	COrwDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	GetClientRect( &m_RectClient);	//top,left=0 bottom,right>0:foCXP
	pDC->DPtoLP( &m_RectClient);	//_Wtop,left=doc(0,0) bottom<0,right>0 
		m_ColorBack = RGB( 255, 255, 255);
	m_ScrollPoint = GetScrollPosition();
	CRect rectClip;
	int Ret = pDC->GetClipBox( &rectClip);
	#ifdef _DEBUG
		if ( Ret == COMPLEXREGION);			//NbsÖ͏dȂ荇E܂B
		else if ( Ret == ERROR);			//foCX ReLXg܂B
		else if ( Ret == NULLREGION);		//NbsÖ悪łB
		else if ( Ret == SIMPLEREGION);		//NbsÖ͏dȂ荇E܂B
	#endif 
	CTypePen* pTypePen;
	CTypeFont* pTypeFont;
	COLORREF Color;
	DrawObj( pDC, &rectClip);	
	for ( int ii = 0; ii < m_pDoc->m_FontArray.GetSize(); ii++)
	{
		pTypeFont = (CTypeFont*)m_pDoc->m_FontArray.GetAt( ii);
		int TextDrawMode;
		LOGFONT logFont = pTypeFont->m_logFont;
		if ( !SetNewFont( pDC, &logFont, &pTypeFont->m_SizeTextBBBBB, &TextDrawMode))
		{
			continue;
		}
		LONG HeightText = -logFont.lfHeight;	//Height>0
		LONG WidthText = logFont.lfWidth;
		if ( WidthText == 0)
		{
			WidthText = (LONG)( HeightText / 2);
		}
		double RadianString = pTypeFont->m_Degree * pi / 180;
		DrawText( pDC, &rectClip, ii, &logFont, TextDrawMode, Color, RadianString, HeightText, WidthText, pTypeFont);
	}
	ReturnOldFont( pDC);
	for ( ii = 0; ii < m_pDoc->m_PenArray.GetSize(); ii++)
	{
		pTypePen = (CTypePen*)m_pDoc->m_PenArray.GetAt( ii);
		int PenWidth = GetPenWidth( pTypePen->m_Width);	//ʕ`̐𓾂
		//͐s\
		if ( pTypePen->m_Type == PS_NULL)
		{
			continue;
		}
		int CountDown = (int)( 2 * PenWidth / (double)pTypePen->m_Width);
		PenWidth += CountDown;
		int CountShade = 0;
		if ( CountDown != 0)
		{
			CountShade = __min( pTypePen->m_WidthShade, PenWidth / CountDown);
		}
		unsigned char BaseValueShade = pTypePen->m_BaseValueShade;
		for ( int SS = 0; SS <= CountShade; SS++)
		{
			Color = pTypePen->m_Color;
			PenWidth -= CountDown;
			if ( PenWidth <= 0)
			{
				break;
			}
			SetShadeColor( &Color, BaseValueShade, CountShade, SS);		//ڂ̐Fݒ肷
			SetNewPen( pDC, pTypePen->m_Type, PenWidth, Color);

			DrawPoint( pDC, &rectClip, ii); 			
			DrawLine( pDC, &rectClip, ii); 			
			DrawCircle( pDC, &rectClip, ii); 			
			DrawArc( pDC, &rectClip, ii); 			
			DrawConic( pDC, &rectClip, ii); 			
			DrawCurve( pDC, &rectClip, ii); 			

			ReturnOldPen( pDC);
		}
	}
	//Ό_`悷
	SetNewPen( pDC, PS_SOLID, 1, RGB( 0, 0, 255));
	DrawOriginAbs( pDC, &rectClip);
	ReturnOldPen( pDC);
	SetNewPen( pDC, PS_SOLID, 1, RGB( 255, 0, 255));
	DrawOrigin( pDC, &rectClip);
	ReturnOldPen( pDC);
}

void COrwView::DrawObj( CDC* pDC, CRect* pRectClip)
{
	for ( int ii = 0; ii < m_pDoc->m_ObjArray.GetSize(); ii++)
	{
		COursOleObj* pObj = m_pDoc->m_ObjArray.GetAt( ii);
		pObj->AssertValid();
		COursOleObj::c_bShowItems = TRUE;
		if ( m_bActive && !pDC->IsPrinting() && IsSelected( pObj))
		{
			COursOleObj::c_bShowItems = TRUE;
		}
		COLORREF Color = 0;
		CPen* pBefPen = NULL;
		SetCounterColorPrint( &Color);		//ɋ߂FFɂ
		pBefPen = SetPen( pDC, PS_SOLID, 1, Color);
		pObj->Draw( this, pDC, pRectClip);
		ReturnPen( pDC, pBefPen);
	}
}

void COrwView::DrawText( CDC* pDC, CRect* pRectClip, int ii, LOGFONT* plogFont, int TextDrawMode, COLORREF Color, double RadianString, LONG HeightText, LONG WidthText, CTypeFont* pTypeFont)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_TextArray.GetSize(); jj++)
	{
		CTexts* pTexts = (CTexts*)m_pDoc->m_TextArray.GetAt( jj);
		if ( pTexts->m_IndexFont != ii)
		{
			continue;
		}
		if ( pTypeFont->m_FormString == FSTR_Norm)
		{
			for ( int kk = 0; kk < pTexts->m_Size; kk++)
			{
				Color = pTexts->m_Texts[ kk].m_Color;
				pTexts->m_Texts[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip,
					plogFont, TextDrawMode, Color, RadianString, HeightText, WidthText);
			}
		}
		else
		{
			for ( int kk = 0; kk < pTexts->m_Size; kk++)
			{
				Color = pTexts->m_Texts[ kk].m_Color;
				pTexts->m_Texts[ kk].DrawOption( pDC, &m_DocBase, &m_DocRatio, pRectClip,
					TextDrawMode, Color, HeightText, WidthText, pTypeFont);
			}
		}
	}
}
void COrwView::DrawPoint( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_DataPointArray.GetSize(); jj++)
	{
		CDataPoints* pDataPoints = (CDataPoints*)m_pDoc->m_DataPointArray.GetAt( jj);
		if ( pDataPoints->m_IndexPen == ii)
		{
			for ( int kk = 0; kk < pDataPoints->m_Size; kk++)
			{
				pDataPoints->m_DataPoints[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
			}
		}
	}
}

void COrwView::DrawLine( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_LineArray.GetSize(); jj++)
	{
		CLines* pLines = (CLines*)m_pDoc->m_LineArray.GetAt( jj);
		if ( pLines->m_IndexPen == ii)
		{
			if ( pLines->m_Slant == 1)
			{
				for ( int kk = 0; kk < pLines->m_Size; kk++)
				{
					pLines->m_Lines[ kk].DrawH( pDC, &m_DocBase, &m_DocRatio, pRectClip);
				}
			}
			else if ( pLines->m_Slant == 2)
			{
				for ( int kk = 0; kk < pLines->m_Size; kk++)
				{
					pLines->m_Lines[ kk].DrawV( pDC, &m_DocBase, &m_DocRatio, pRectClip);
				}
			}
			else if ( pLines->m_Slant == 4)
			{
				for ( int kk = 0; kk < pLines->m_Size; kk++)
				{
					pLines->m_Lines[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
				}
			}
		}
	}
}

void COrwView::DrawCircle( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_CircleArray.GetSize(); jj++)
	{
		CCircles* pCircles = (CCircles*)m_pDoc->m_CircleArray.GetAt( jj);
		if ( pCircles->m_IndexPen == ii)
		{
			for ( int kk = 0; kk < pCircles->m_Size; kk++)
			{
				pCircles->m_Circles[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
			}
		}
	}
}
			
void COrwView::DrawArc( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_ArcArray.GetSize(); jj++)
	{
		CArcs* pArcs = (CArcs*)m_pDoc->m_ArcArray.GetAt( jj);
		if ( pArcs->m_IndexPen == ii)
		{
			for ( int kk = 0; kk < pArcs->m_Size; kk++)
			{
				pArcs->m_Arcs[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
			}
		}
	}
}

void COrwView::DrawConic( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_ConicArray.GetSize(); jj++)
	{
		CConics* pConics = (CConics*)m_pDoc->m_ConicArray.GetAt( jj);
		if ( pConics->m_IndexPen == ii)
		{
			for ( int kk = 0; kk < pConics->m_Size; kk++)
			{
				pConics->m_Conics[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
			}
		}
	}
}
			
void COrwView::DrawCurve( CDC* pDC, CRect* pRectClip, int ii)
{ 			
	for ( int jj = 0; jj < m_pDoc->m_CurveArray.GetSize(); jj++)
	{
		CCurves* pCurves = (CCurves*)m_pDoc->m_CurveArray.GetAt( jj);
		if ( pCurves->m_IndexPen == ii)
		{
			for ( int kk = 0; kk < pCurves->m_Size; kk++)
			{
				pCurves->m_Curves[ kk].Draw( pDC, &m_DocBase, &m_DocRatio, pRectClip);
			}
		}
	}
}

void COrwView::DrawOriginAbs( CDC* pDC, CRect* pRectClip)
{
	//Ό_\//m_ColorBlue
	BOOL InnerRect = FALSE;
	CRect2D DrawRect2D( pRectClip);
	CPoint2D Spoint( 0, 0);
	Spoint = Spoint.DataToDoc( &m_DocBase, &m_DocRatio);
	CPoint2D EpointA = Spoint;
	CPoint2D EpointB = Spoint;
	EpointA.x += 100 / 2;
	EpointB.y += 100 / 2;
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)EpointA.x, (int)EpointA.y);
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)EpointB.x, (int)EpointB.y);
}

void COrwView::DrawOrigin( CDC* pDC, CRect* pRectClip)
{
	//΍W`悷
	double pi = 3.141592653589793;
	CPoint2D Spoint, Epoint;
	BOOL InnerRect = FALSE;
	CRect2D DrawRect2D( pRectClip);
	//m_pDoc->m_DegreeRelative=0
	double Radian = 0 * pi / 180;
	Spoint = m_pDoc->m_OriginRelative.DataToDoc( &m_DocBase, &m_DocRatio);
	Epoint.x = Spoint.x + 100 * cos( Radian);		//m_AppDraw.m_LengthAxis//΍W̎
	Epoint.y = Spoint.y + 100 * sin( Radian);
	SortPoint( &Spoint, &Epoint);
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)Epoint.x, (int)Epoint.y);
	Radian = 90 * pi / 180;
	Spoint = m_pDoc->m_OriginRelative.DataToDoc( &m_DocBase, &m_DocRatio);
	Epoint.x = Spoint.x + 100 * cos( Radian);
	Epoint.y = Spoint.y + 100 * sin( Radian);
	SortPoint( &Spoint, &Epoint);
	pDC->MoveTo( (int)Spoint.x, (int)Spoint.y);	
	pDC->LineTo( (int)Epoint.x, (int)Epoint.y);
}

/////////////////////////////////////////////////////////////////////////////

void COrwView::SetCounterColorPrint( COLORREF* pColor)
{
	//ɋ߂FFɂ
	BYTE RValue = GetRValue( *pColor);
	BYTE GValue = GetGValue( *pColor);
	BYTE BValue = GetBValue( *pColor);
	int LimitCounter = 255 - 55;		//55//FFɂRGBEl
	if ( RValue > LimitCounter && GValue > LimitCounter && BValue > LimitCounter)
	{
		*pColor = RGB( 255 - RValue, 255 - GValue, 255 - BValue);
	}
}

void COrwView::SetShadeColor( COLORREF* pColor, unsigned char BaseValueShade, 
		unsigned char WidthShade, int Index)
{
	//ڂ̐Fݒ肷
	//Index͊O()Ƃ
	if ( WidthShade == 0)
	{
		return;
	}
	//w^Cv
	double BaseValue = BaseValueShade / 100.0;
	double Ratio = 1 - pow( BaseValue, WidthShade - Index);
	BYTE RValue = GetRValue( *pColor);
	BYTE GValue = GetGValue( *pColor);
	BYTE BValue = GetBValue( *pColor);
	if ( m_ColorBack == RGB( 255, 255, 255) ||
		 m_ColorBack == RGB( 235, 255, 255))		//225=>235=>245=>235//F)
	{
		BYTE RValueB = 255 - RValue;
		BYTE GValueB = 255 - GValue;
		BYTE BValueB = 255 - BValue;
		RValueB = (unsigned char)( RValueB * Ratio);
		GValueB = (unsigned char)( GValueB * Ratio);
		BValueB = (unsigned char)( BValueB * Ratio);
		*pColor = RGB( RValue + RValueB, GValue + GValueB, BValue + BValueB);
	}
	else if ( m_ColorBack == RGB( 0, 0, 0))		//m_AppColor.m_ColorBlack)
	{
		RValue = (unsigned char)( RValue * Ratio);
		GValue = (unsigned char)( GValue * Ratio);
		BValue = (unsigned char)( BValue * Ratio);
		*pColor = RGB( RValue, GValue, BValue);
	}
}

/////////////////////////////////////////////////////////////////////////////

BOOL COrwView::SetNewFont( CDC* pDC, LOGFONT* plogFont, CSize* pSizeText, int* pTextDrawMode)
{
	*pTextDrawMode = 1;
	plogFont->lfHeight = (long)( -pSizeText->cy / 10.0 * m_DocRatio);
	plogFont->lfWidth = (long)( pSizeText->cx / 10.0 * m_DocRatio);
	if ( plogFont->lfHeight > -1) return FALSE;
	else if ( plogFont->lfHeight > -6)
	{
		*pTextDrawMode = 0;
	}
	else if ( plogFont->lfHeight < -10000) return FALSE;
	m_pNewFont = new CFont();
	if ( !m_pNewFont->CreateFontIndirect( plogFont))
	{
		delete m_pNewFont;
		return FALSE;
	}
	CFont* pBeforeFont = pDC->SelectObject( m_pNewFont);
	if ( pBeforeFont == NULL)
	{
		return FALSE;
	}
	if ( m_pOldFont == NULL)
	{
		m_pOldFont = pBeforeFont;		//ŏFontۑ
	}
	else
	{
		pBeforeFont->DeleteObject();	//GDI̐؂藣̂
		delete pBeforeFont;
	}
	return TRUE;
}

CPen* COrwView::SetPen( CDC* pDC, int Type, int Width, COLORREF Color)
{
	//ʕ\p̃y
	m_pNewPen = new CPen();
	if ( !m_pNewPen->CreatePen( Type, Width, Color))
	{
		delete m_pNewPen;
		return NULL;
	}
	CPen* pBeforePen = pDC->SelectObject( m_pNewPen);
	return pBeforePen;
}

void COrwView::ReturnPen( CDC* pDC, CPen* pBeforePen)
{
	//ʕ\py̖ƑO̉
	if ( pBeforePen == NULL)
	{
		return;
	}
	CPen* pCurrentPen = pDC->SelectObject( pBeforePen);
	if ( pCurrentPen == NULL)
	{
		ASSERT( FALSE);
		return;
	}
	pCurrentPen->DeleteObject();
	delete pCurrentPen;
}

BOOL COrwView::SetNewPen( CDC* pDC, int Type, int Width, COLORREF Color)
{
	//OtBbNIuWFNgJԂgɂ́AIuWFNg񊄂蓖ĂĂAKvɂȂ邽тɃfoCXReLXgɑI܂B
	//̏ꍇAIuWFNgsvɂȂƂ́AK폜܂B
	//OtBbN IuWFNg̍쐬ɂ́A2 ̕@܂B
	//2 iK̍\zBIuWFNg̍\zƏʁXɍs܂BRXgN^ŃIuWFNg\zA֐gď܂B
	//2 iKō\zSłB
	//1 iK̍\zł́AԈႦ邩AmۂłȂƁARXgN^OX[邱Ƃ܂B
	//2 iK̍\zł͂̂悤Ȗł܂AG[̃`FbNKvɂȂ܂B
	//ǂ̕@ō쐬ꂽIuWFNgłAIuWFNg̔j@͓łB

	m_pNewPen = new CPen();
	if ( !m_pNewPen->CreatePen( Type, Width, Color))
	{
		delete m_pNewPen;
		return FALSE;
	}
	CPen* pBeforePen = pDC->SelectObject( m_pNewPen);
	if ( pBeforePen == NULL)
	{
		return FALSE;
	}
	if ( m_pOldPen == NULL)
	{
		m_pOldPen = pBeforePen;	//ŏPenۑ
	}
	return TRUE;
}

BOOL COrwView::ReturnOldPen( CDC* pDC)
{
	if ( m_pOldPen == NULL) return FALSE;
	CPen* pCurrentPen = pDC->SelectObject( m_pOldPen);
	if ( pCurrentPen == NULL)
	{
		ASSERT( FALSE);
		m_pOldPen = NULL;
		return FALSE;
	}
	pCurrentPen->DeleteObject();
	delete pCurrentPen;
	m_pOldPen = NULL;
	return TRUE;
}

int COrwView::GetPenWidth( int WidthPen)
{
	//ʕ`̐𓾂
	if ( WidthPen == 1)
	{
		return 1;
	}
	double Width = WidthPen * m_DocRatio / 10;			//WidthPen(0.1mmP)
	int WidthDraw = (int)Width;
	if ( Width - WidthDraw > 0.4 || WidthDraw == 0)
	{
		WidthDraw++;
	}
	if ( WidthDraw < 6)									//Ƃĕ`o
	{
		return 6;
	}
	return WidthDraw;
}

BOOL COrwView::ReturnOldFont( CDC* pDC)
{
	if ( m_pOldFont == NULL) return FALSE;
	CFont* pCurrentFont = pDC->SelectObject( m_pOldFont);
	if ( pCurrentFont == NULL) return FALSE;
	pCurrentFont->DeleteObject();
	delete pCurrentFont;
	m_pOldFont = NULL;
	return TRUE;
}

void COrwView::SetCenterViewParam()
{
	//f[^_r[̃Z^[ɒu
	CSize sizeDoc( 32000, 32000);
	m_ScrollPoint.x = (long)( sizeDoc.cx / 2) - (long)( ( m_RectClient.right - m_RectClient.left) / 2);
	m_ScrollPoint.y = -(long)( sizeDoc.cy / 2) + (long)fabs( ( ( m_RectClient.bottom - m_RectClient.top) / 2));
}

void COrwView::InitScrollSizes()
{
	//Om_RectClient̃ZbgKv
	m_ScrollSize.cx = (int)( ( m_RectClient.right - m_RectClient.left) / 20);
	m_ScrollSize.cy = (int)fabs( ( ( m_RectClient.bottom - m_RectClient.top) / 20));
	SIZE sizePage = { m_ScrollSize.cx * 10, m_ScrollSize.cy * 10};
	CSize sizeDoc( 32000, 32000);
	SetScrollSizes( MM_LOMETRIC, sizeDoc, sizePage, m_ScrollSize);
	ScrollToPosition( m_ScrollPoint);
}

BOOL COrwView::OpenOur( CString* pFilePath, CString* pFileName) 
{
	m_pDoc->UpdateAllViews( NULL, 0L, NULL);
	SendMessage( WM_PAINT, 0, 0);
	if ( !m_pDoc->SetOurData( pFilePath))
	{
		return FALSE;
	}
	m_pDoc->GetDataSize();
	FullDsp();
	return TRUE;
}

BOOL COrwView::FullDsp()
{
	double Sx = m_pDoc->m_DataRect2D.left;
	double Sy = m_pDoc->m_DataRect2D.top;
	double Ex = m_pDoc->m_DataRect2D.right;
	double Ey = m_pDoc->m_DataRect2D.bottom;
	m_ViewCenter = CPoint2D( ( Sx + Ex) / 2, ( Sy + Ey) / 2);
	double Dx = ( Ex - Sx) * 1.1;		//m_AppDraw.m_RatioFull//S\̃f[^Ɖʂ̊
	double Dy = ( Ey - Sy) * 1.1;
	double NewDocRatio;
	if ( Dx == 0 && Dy == 0) NewDocRatio = 1;
	else if ( Dx == 0) NewDocRatio = m_RectClient.Height() / Dy;
	else if ( Dy == 0) NewDocRatio = m_RectClient.Width() / Dx;		//P̎//000928
	else NewDocRatio = min( m_RectClient.Width() / Dx, m_RectClient.Height() / Dy);
	CPoint2D NewDocBase;
	if ( SetDocBase( &NewDocBase, &NewDocRatio, 3))
	{
		SetBase( NewDocBase, TRUE);
		SetRatio( NewDocRatio, TRUE);
		SetCenterViewParam();
		InitScrollSizes();
		Invalidate( TRUE);
		SendMessage( WM_PAINT, 0, 0);
	}
	return FALSE;
}

BOOL COrwView::SetDocBase( CPoint2D* pNewDocBase, double* pDocRatio, int Mode)
{
	//Mode:1(X) 2(Y) 3(XY)
	if ( *pDocRatio > 1e100)
	{
		return FALSE;
	}
	if ( *pDocRatio < 1e-100)
	{
		return FALSE;
	}
	CSize sizeDoc( 32000, 32000);
	double RatioX = m_ViewCenter.x * 2 * *pDocRatio / sizeDoc.cx;
	double RatioY = m_ViewCenter.y * 2 * *pDocRatio / sizeDoc.cy;
	if ( fabs( RatioX) > 1e11)
	{
		if ( Mode == 1 || Mode == 3)
		{
			return FALSE;
		}
	}
	if ( fabs( RatioY) > 1e11)
	{
		if ( Mode == 2 || Mode == 3)
		{
			return FALSE;
		}
	}
	double RealDocX = sizeDoc.cx / ( 2 * *pDocRatio);
	double RealDocY = sizeDoc.cx / ( 2 * *pDocRatio);
	if ( fabs( RealDocX) > 1e100)
	{
		if ( Mode == 1 || Mode == 3)
		{
			return FALSE;
		}
	}
	if ( fabs( RealDocY) > 1e100)
	{
		if ( Mode == 2 || Mode == 3)
		{
			return FALSE;
		}
	}
	if ( Mode == 1 || Mode == 3)
	{
		pNewDocBase->x = m_ViewCenter.x - sizeDoc.cx / ( 2 * *pDocRatio);
	}
	else
	{
		pNewDocBase->x = m_DocBase.x;
	}
	if ( Mode == 2 || Mode == 3)
	{
		pNewDocBase->y = m_ViewCenter.y + sizeDoc.cy / ( 2 * *pDocRatio);
	}
	else
	{
		pNewDocBase->y = m_DocBase.y;
	}
	return TRUE;
}

void COrwView::SetRatio( double DocRatio, BOOL AppSet)
{
	m_DocRatio = DocRatio;
}

void COrwView::SetBase( CPoint2D DocBase, BOOL AppSet)
{
	m_DocBase = DocBase;
}

//////////////////////////////////////////////////////////////////////////////////////

